%global namedreltag .RELEASE
%global namedversion %{version}%{?namedreltag}
Name:          springframework-security
Version:       3.1.7
Release:       1%{?dist}
Summary:       Modular Java/J2EE application security framework
# Public Domain: crypto/src/main/java/org/springframework/security/crypto/codec/Base64.java
# ISC: crypto/src/main/java/org/springframework/security/crypto/bcrypt/BCrypt.java
# crypto/src/test/java/org/springframework/security/crypto/bcrypt/BCryptTests.java
License:       ASL 2.0 and ISC and Public Domain
Url:           http://static.springsource.org/spring-security/site/index.html
Source0:       https://github.com/SpringSource/spring-security/archive/%{namedversion}.tar.gz
Source1:       http://repo1.maven.org/maven2/org/springframework/security/spring-security-acl/%{version}.RELEASE/spring-security-acl-%{version}.RELEASE.pom
Source2:       http://repo1.maven.org/maven2/org/springframework/security/spring-security-cas/%{version}.RELEASE/spring-security-cas-%{version}.RELEASE.pom
Source3:       http://repo1.maven.org/maven2/org/springframework/security/spring-security-config/%{version}.RELEASE/spring-security-config-%{version}.RELEASE.pom
Source4:       http://repo1.maven.org/maven2/org/springframework/security/spring-security-core/%{version}.RELEASE/spring-security-core-%{version}.RELEASE.pom
Source5:       http://repo1.maven.org/maven2/org/springframework/security/spring-security-crypto/%{version}.RELEASE/spring-security-crypto-%{version}.RELEASE.pom
Source6:       http://repo1.maven.org/maven2/org/springframework/security/spring-security-ldap/%{version}.RELEASE/spring-security-ldap-%{version}.RELEASE.pom
Source7:       http://repo1.maven.org/maven2/org/springframework/security/spring-security-openid/%{version}.RELEASE/spring-security-openid-%{version}.RELEASE.pom
Source8:       http://repo1.maven.org/maven2/org/springframework/security/spring-security-remoting/%{version}.RELEASE/spring-security-remoting-%{version}.RELEASE.pom
Source9:       http://repo1.maven.org/maven2/org/springframework/security/spring-security-taglibs/%{version}.RELEASE/spring-security-taglibs-%{version}.RELEASE.pom
Source10:      http://repo1.maven.org/maven2/org/springframework/security/spring-security-web/%{version}.RELEASE/spring-security-web-%{version}.RELEASE.pom

Source11:      %{name}-3.1.4.RELEASE-pom.xml

# tomcat 7.x apis support
Patch0:        %{name}-3.1.3.RELEASE-web-FilterInvocation.patch
# build fix for apacheds 1.5.7 and apacheds-shared 0.9.19
Patch1:        %{name}-3.1.4.RELEASE-ApacheDSContainer.patch

Patch2:        %{name}-3.1.4.RELEASE-osgi-support.patch

BuildRequires: java-devel

# build deps
BuildRequires: mvn(com.google.inject:guice)
BuildRequires: mvn(commons-logging:commons-logging)
BuildRequires: mvn(aopalliance:aopalliance)
BuildRequires: mvn(javax.annotation:jsr250-api)
BuildRequires: mvn(ldapsdk:ldapsdk)
BuildRequires: mvn(net.sf.ehcache:ehcache-core)
BuildRequires: mvn(org.apache.directory.server:apacheds-core)
BuildRequires: mvn(org.apache.directory.server:apacheds-core-api)
BuildRequires: mvn(org.apache.directory.server:apacheds-core-entry)
BuildRequires: mvn(org.apache.directory.server:apacheds-jdbm-partition)
BuildRequires: mvn(org.apache.directory.server:apacheds-protocol-ldap)
BuildRequires: mvn(org.apache.directory.server:apacheds-protocol-shared)
BuildRequires: mvn(org.apache.directory.server:apacheds-server-jndi)
BuildRequires: mvn(org.apache.directory.server:apacheds-xdbm-base)
BuildRequires: mvn(org.apache.directory.shared:shared-ldap)
BuildRequires: mvn(org.apache.httpcomponents:httpclient)
BuildRequires: mvn(org.apache.tomcat:tomcat-jsp-api)
BuildRequires: mvn(org.apache.tomcat:tomcat-servlet-api)
BuildRequires: mvn(org.aspectj:aspectjweaver)
BuildRequires: mvn(org.jasig.cas.client:cas-client-core)
BuildRequires: mvn(org.openid4java:openid4java-nodeps)
BuildRequires: mvn(org.springframework:spring-core)
BuildRequires: mvn(org.springframework:spring-aop)
BuildRequires: mvn(org.springframework:spring-beans)
BuildRequires: mvn(org.springframework:spring-context)
BuildRequires: mvn(org.springframework:spring-expression)
BuildRequires: mvn(org.springframework:spring-jdbc)
BuildRequires: mvn(org.springframework:spring-web)
BuildRequires: mvn(org.springframework:spring-tx)
BuildRequires: mvn(org.springframework.ldap:spring-ldap-core)

# dep required by cas-client
BuildRequires: mvn(net.shibboleth:parent:pom:)
# dep required by apacheds
BuildRequires: mvn(org.apache.directory.server:apacheds-utils)

BuildRequires: maven-local
BuildRequires: maven-plugin-bundle

%if 0
# Default build tools and deps
BuildRequires: antlr-tool
BuildRequires: apache-commons-cli
BuildRequires: emma
BuildRequires: gradle
BuildRequires: groovy
BuildRequires: objectweb-asm
# test deps
BuildRequires: apache-commons-collections
BuildRequires: apache-commons-codec
BuildRequires: cglib
BuildRequires: hsqldb
BuildRequires: jboss-jstl-1.2-api
BuildRequires: junit
# unavailable test deps
BuildRequires: mvn(org.python:jython) >= 2.5.0
BuildRequires: mvn(org.springframework:spring-test)
# required by gradle build
BuildRequires: logback
BuildRequires: mockito
BuildRequires: powermock-api-mockito
BuildRequires: powermock-api-support
BuildRequires: powermock-common
BuildRequires: powermock-core
BuildRequires: powermock-junit4
BuildRequires: powermock-reflect
BuildRequires: slf4j
BuildRequires: spock-core
BuildRequires: springframework-context-support
%endif

BuildArch:     noarch

%description
Spring Security is a Java/Java EE framework that provides advanced
authentication, authorization and other comprehensive security features for
enterprise applications. In addition to having a comprehensive list of
security functionality, Spring Security is very configurable and employs the
Spring Framework for configuration, it allows for reuse and portability of
security components, and it can also be used with non-Spring applications.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n spring-security-%{namedversion}
find .  -name "*.jar" -print -delete
find .  -name "*.class" -print -delete
%patch0 -p0
sed -i "s|Map<String,Object> parameters = request.getParameterMap();|Map<String,String[]> parameters = request.getParameterMap();|" \
  web/src/main/java/org/springframework/security/web/savedrequest/DefaultSavedRequest.java
%patch1 -p0

cp -p %{SOURCE1} acl/pom.xml
cp -p %{SOURCE2} cas/pom.xml
cp -p %{SOURCE3} config/pom.xml
cp -p %{SOURCE4} core/pom.xml
cp -p %{SOURCE5} crypto/pom.xml
cp -p %{SOURCE6} ldap/pom.xml
cp -p %{SOURCE7} openid/pom.xml
cp -p %{SOURCE8} remoting/pom.xml
cp -p %{SOURCE9} taglibs/pom.xml
cp -p %{SOURCE10} web/pom.xml

%patch2 -p1 -F1
cp -p %{SOURCE11} pom.xml

for f in acl cas config core crypto ldap openid remoting taglibs web; do
%pom_add_plugin org.apache.maven.plugins:maven-compiler-plugin:3.0 ${f} '
<configuration>
 <source>1.5</source>
 <target>1.5</target>
</configuration>'
done

%pom_remove_dep javax.servlet:jsp-api taglibs/pom.xml
%pom_xpath_inject "pom:dependencies" "
  <dependency>
    <groupId>org.apache.tomcat</groupId>
    <artifactId>tomcat-jsp-api</artifactId>
    <version>2.0</version>
    <scope>provided</scope>
    <optional>true</optional>
  </dependency>" taglibs/pom.xml

for p in cas config openid taglibs web; do
sed -i "s|<groupId>javax.servlet</groupId>|<groupId>org.apache.tomcat</groupId>|" ${p}/pom.xml
sed -i "s|<artifactId>servlet-api</artifactId>|<artifactId>tomcat-servlet-api</artifactId>|" ${p}/pom.xml
sed -i "s|<version>2.5</version>|<version>7.0.40</version>|" ${p}/pom.xml
done

%pom_add_dep org.springframework.security:spring-security-crypto:'${project.version}' core/pom.xml
%pom_xpath_inject "pom:dependencies" "
  <dependency>
    <groupId>org.apache.directory.server</groupId>
    <artifactId>apacheds-core-api</artifactId>
    <version>1.5.5</version>
    <scope>compile</scope>
    <optional>true</optional>
  </dependency>" ldap/pom.xml
%pom_xpath_inject "pom:dependencies" "
  <dependency>
    <groupId>org.apache.directory.server</groupId>
    <artifactId>apacheds-jdbm-partition</artifactId>
    <version>1.5.5</version>
    <scope>compile</scope>
    <optional>true</optional>
  </dependency>" ldap/pom.xml
%pom_xpath_inject "pom:dependencies" "
  <dependency>
    <groupId>org.apache.directory.server</groupId>
    <artifactId>apacheds-xdbm-base</artifactId>
    <version>1.5.5</version>
    <scope>compile</scope>
    <optional>true</optional>
  </dependency>" ldap/pom.xml

sed -i "s|<artifactId>ehcache</artifactId>|<artifactId>ehcache-core</artifactId>|" acl/pom.xml cas/pom.xml core/pom.xml
sed -i "s|<artifactId>aspectjrt</artifactId>|<artifactId>aspectjweaver</artifactId>|" core/pom.xml

%if 0
# require unavailable build deps org.springframework spring-test and gradle maven plugin
rm -r acl/src/test/java/* \
  cas/src/test/java/* \
  config/src/test/java/* \
  config/src/test/groovy/* \
  core/src/test/java/* \
  ldap/src/integration-test/java/* \
  ldap/src/test/java/* \
  openid/src/test/java/* \
  remoting/src/test/java/* \
  taglibs/src/test/java/* \
  web/src/test/java/*
%endif

%build
# test skipped for unavailable test deps
%mvn_package :spring-security-project __noinstall
%mvn_build -f -- -Dproject.build.sourceEncoding=UTF-8

%install
%mvn_install

%files -f .mfiles
%dir %{_javadir}/%{name}
%doc license.txt notice.txt readme.txt

%files javadoc -f .mfiles-javadoc
%doc license.txt notice.txt

%changelog
* Tue Aug 19 2014 Michal Srb <msrb@redhat.com> - 3.1.7-1
- Update to upstream release 3.1.7
- Resolves: CVE-2014-3527

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.1.6-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Wed Mar 12 2014 Michal Srb <msrb@redhat.com> - 3.1.6-1
- Update to upstream release 3.1.6 (Fixes CVE-2014-0097)

* Tue Mar 04 2014 Stanislav Ochotnicky <sochotnicky@redhat.com> - 3.1.4-4
- Use Requires: java-headless rebuild (#1067528)

* Tue Aug 06 2013 gil cattaneo <puntogil@libero.it> 3.1.4-3
- switch to XMvn
- minor changes to adapt to current guideline

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.1.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Sat Jun 01 2013 gil cattaneo <puntogil@libero.it> 3.1.4-1
- update to 3.1.4.RELEASE

* Fri Nov 16 2012 gil cattaneo <puntogil@libero.it> 3.1.3-1
- initial rpm
